Welcome

首页 / 软件开发 / 数据结构与算法 / POJ 2385 Apple Catching (DP)

POJ 2385 Apple Catching (DP)2014-07-30 csdn博客 synapse7Description
It is a little known fact that cows love apples. Farmer John has two apple trees (which are conveniently numbered 1 and 2) in his field, each full of apples. Bessie cannot reach the apples when they are on the tree, so she must wait for them to fall. However, she must catch them in the air since the apples bruise when they hit the ground (and no one wants to eat bruised apples). Bessie is a quick eater, so an apple she does catch is eaten in just a few seconds.

Each minute, one of the two apple trees drops an apple. Bessie, having much practice, can catch an apple if she is standing under a tree from which one falls. While Bessie can walk between the two trees quickly (in much less than a minute), she can stand under only one tree at any time. Moreover, cows do not get a lot of exercise, so she is not willing to walk back and forth between the trees endlessly (and thus misses some apples).

Apples fall (one each minute) for T (1 <= T <= 1,000) minutes. Bessie is willing to walk back and forth at most W (1 <= W <= 30) times. Given which tree will drop an apple each minute, determine the maximum number of apples which Bessie can catch. Bessie starts at tree 1.

Input
* Line 1: Two space separated integers: T and W

* Lines 2..T+1: 1 or 2: the tree that will drop an apple each minute.

Output
* Line 1: The maximum number of apples Bessie can catch without walking more than W times.

Sample Input

7 2
2
1
2
1
2
1
1

Sample Output

6

Hint
INPUT DETAILS:

Seven apples fall - one from tree 2, then two in a row from tree 1, then two in a row from tree 2, then two in a row from tree 1. Bessie is willing to walk from one tree to the other twice.

OUTPUT DETAILS:

Bessie can catch six apples by staying under tree 1 until the first two have dropped, then moving to tree 2 for the next two, then returning back to tree 1 for the final two.

Source
USACO 2004 November

思路全部写在注释中了:

/*16ms,388KB*/ #include<cstdio>#include<algorithm>using namespace std; int dp[31];///dp[i]表示进行了i次移动后接到(吃掉)的苹果数的最大值///偶数为第一棵树,奇数为第二棵树///所以开一个一维数组就行 int main(){int i, n, w, tree;scanf("%d%d", &n, &w);while (n--){scanf("%d", &tree);if (tree == 1){for (i = 2; i <= w; i += 2)///第一棵树dp[i] = max(dp[i], dp[i - 1]) + 1;///要么不换位置,要么换位置++dp[0];///不进行任何移动时所能接到的苹果数}else{for (i = 1; i <= w; i += 2)///第二棵树dp[i] = max(dp[i], dp[i - 1]) + 1;}//for (i = 0; i <= w; ++i)//printf("%d	", dp[i]);//putchar(10);//putchar(10);}printf("%d
", max(dp[w - 1], dp[w]));return 0;}